import pyddl
import sys
import numpy as np

n = 100

pyddl.init()

initial_values = [x for x in range(n)]

# array 1
n1 = 6

arr1 = np.array([0 for x in range(n1)], dtype=np.float32)

res1, buf1 = pyddl.malloc(64, n1 * 4)

# array 2

n2 = 13

arr2 = np.array([0 for x in range(n2)], dtype=np.float32)

res2, buf2 = pyddl.malloc(64, n2 * 4)

# array 3

n3 = 22

arr3 = np.array([0 for x in range(n3)], dtype=np.float32)

res3, buf3 = pyddl.malloc(64, n3 * 4)

# destination

src = np.array([x for x in range(n1+n2+n3)], dtype=np.float32)

res_src, buf_src = pyddl.malloc(64, (n1 + n2 + n3) * 4)

pyddl.memcpy_host_to_device(buf_src, src)

pyddl.memsync()

pyddl.memcpy_scatter(np.array([buf1, buf2, buf3], dtype=np.uint64), np.array([n1*4,n2*4,n3*4], dtype=np.uint64), 3, buf_src)

pyddl.memsync()

pyddl.memcpy_device_to_host(arr1, buf1)

pyddl.memcpy_device_to_host(arr2, buf2)

pyddl.memcpy_device_to_host(arr3, buf3)

pyddl.memsync()

pyddl.free(buf1)
pyddl.free(buf2)
pyddl.free(buf3)
pyddl.free(buf_src)

# Verify that the memcpy_scatter produced the correct result
result = np.array_equal(np.array([x for x in range(n1)], dtype=np.float32), arr1) and np.array_equal(np.array([x + n1 for x in range(n2)], dtype=np.float32), arr2) and np.array_equal(np.array([x + n1 + n2 for x in range(n3)], dtype=np.float32), arr3)

pyddl.finalize()

if result:
    sys.exit(0)
else:
    sys.exit(1)

